<template>
  <form @submit.prevent="submit" class="contact-form">
    <div class="form-group">
      <label for="company">O nome da sua empresa</label>
      <input type="text" placeholder="Digite o nome da sua empresa " id="company" name="company" v-model="fields.company" required autofocus>
      <div class="alert alert-danger" v-if="errors && errors.company">
        {{ errors.company[0] }}
      </div>
    </div>
    <div class="form-group">
      <label for="name">Seu nome completo</label>
      <input type="text" placeholder="Digite seu nome completo " id="name" name="name" v-model="fields.name" required>
      <div class="alert alert-danger" v-if="errors && errors.name">
        {{ errors.name[0] }}
      </div>
    </div>
    <div class="form-group">
      <label for="phone">DDD e Telefone </label>
      <input type="text" data-inputmask="'mask': '(99) 99999-9999'" placeholder="Digite número de telefone " id="phone" name="phone" v-model="fields.phone" required>
      <div class="alert alert-danger" v-if="errors && errors.phone">
        {{ errors.phone[0] }}
      </div>
    </div>
    <div class="form-group">
      <label for="email">Seu E-mail </label>
      <input type="email" placeholder="Digite seu e-mail " id="email" name="email" v-model="fields.email" required>
      <div class="alert alert-danger" v-if="errors && errors.email">
        {{ errors.email[0] }}
      </div>
    </div>
    <div class="form-group">
      <label for="email">Selecione o assunto </label>
      <select class="form-control" id="subject_contact_id" name="subject_contact_id" v-model="fields.subject_contact_id" required>
        <option v-for="subject in subjects"
            :value="subject.id">{{ subject.title }}
        </option>
      </select>
      <div class="alert alert-danger" v-if="errors && errors.subject_contact_id">
        {{ errors.subject_contact_id[0] }}
      </div>
    </div>
    <div class="form-group mb-0">
      <label for="message">Sua mensagem </label>
      <textarea id="message" name="message" placeholder="Digite sua mensagem" v-model="fields.message" required></textarea>
      <div class="alert alert-danger" v-if="errors && errors.message">
        {{ errors.message[0] }}
      </div>
    </div>
    <div class="form-check">
      <input type="checkbox" id="check" name="newsletter" value="1" v-model="fields.newsletter">
      <label for="check">Aceito receber e-mails, newsletters e mensagens promocionais</label>
    </div>
    <div class="alert alert-success" v-show="success">Recebemos seu contato, em breve retornaremos!</div>
    <div class="form-group">
      <input type="submit" value="Enviar mensagem">
    </div>
  </form>
</template>
<script>
  export default {
    data() {
      return {
        subjects: null,
        fields: {},
        success: false,
        errors: {}
      }
    },
    mounted() {
      axios.get('/api/subjects').then(response => {
        this.subjects = response.data.data;
      })
    },
    methods: {
      submit() {
        axios.post('/api/contact', this.fields).then(response => {
          this.fields = {};
          this.success = true;
          this.errors = {};
        }).catch(error => {
          if (error.response.status == 422) {
            this.errors = error.response.data.errors;
          }
          console.log('Error');
        });
      }
    }
  }
</script>